#ifndef INSTALLDIALOG_H
#define INSTALLDIALOG_H

/* Project Specific Includes */
#include "main.h"

/* Library Includes */
#include <qdialog.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qframe.h>
#include <qpixmap.h>
#include <qlineedit.h>
#include <qmessagebox.h>

const unsigned short MAX_PANELS=3;

class
installDialog : public QDialog
{
	Q_OBJECT
private:
	QFrame *panel1, *panel2, *panel3, *finishedPanel;
	QLabel *lblTitle1, *lblDescription1, *lblLogo, *lblVersion;
	QLabel *lblTitle2, *lblDescription2, *lblICQNumber, *lblPassword, *lblNickname;
	QLineEdit *edtICQNumber, *edtPassword, *edtNickname, *edtSound;
	QLabel *lblTitle3, *lblDescription3;
	QLabel *lblTitleFinished, *lblDescriptionFinished;
	QPushButton *btnAbout, *btnCancel, *btnBack, *btnNext;
	int currentPanel;
public:
	installDialog(QWidget *parent=0, char *name=0);
	 friend int main(int, char **);
protected:
	void saveConfig();
public slots:
	void clickAbout();
    void clickCancel();
	void clickBack();
	void clickNext();
	void updateButtons();
signals:
	void finished();
	void panelChange();
};
#endif
