#include <qpainter.h>
#include <qpixmap.h>

#include "connectbutton.h"

#include "pics/status_online.xpm"
#include "pics/status_offline.xpm"
#include "pics/status_private.xpm"
#include "pics/status_dnd.xpm"
#include "pics/status_away.xpm"
#include "pics/status_freeforchat.xpm"
#include "pics/status_occupied.xpm"
#include "pics/status_na.xpm"

#include "pics/connect1.xpm"
#include "pics/connect2.xpm"
#include "pics/connect3.xpm"
#include "pics/connect4.xpm"
#include "pics/connect5.xpm"
#include "pics/connect6.xpm"
#include "pics/connect7.xpm"
#include "pics/connect8.xpm"
     

//
// ----ICQPopupMenu --------------------------------------------
//

ICQPopupMenu::ICQPopupMenu( QWidget *parent=0 )  : QPopupMenu(parent)
{

}

void ICQPopupMenu::hide() 
{
   QPopupMenu::hide();
   emit hideMenu();
}

//
// ----PopupButton ---------------------------------------------
//

void PopupButton::drawButtonLabel(QPainter *p)
{
    if (width() > 80)
    	p->drawPixmap(6, 4, lpixmap);
    else 	// center pixmap 
        p->drawPixmap(( (width() - lpixmap.width()) / 2) - 2, 4,  lpixmap);

    if (width() > 80)	// draw the text
    	p->drawText(lpixmap.width()+13, 0, width()-13-lpixmap.width(), height(), AlignLeft|AlignVCenter, ltext);
}

PopupButton::PopupButton(QWidget *parent, const char *name) : QPushButton(parent, name)
{
  timerid = -1;
  setStatus(stOffline);
  setToggleButton( true );
}

PopupButton::~PopupButton()
{
  killTimers();
}

void PopupButton::setStatus(icqStatus status)
{
  switch(status)
  {
    case stOnline:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = online_xpm;
      ltext = "Online";
      break;
    case stAway:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = away_xpm;
      ltext = "Away";
      break;
    case stDND:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = dnd_xpm;
      ltext = "DND";
      break;
    case stNA:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = na_xpm;
      ltext = "N/A";
      break;
    case stOccupied:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = occupied_xpm;
      ltext = "Occupied";
      break;
    case stFFC:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = freeforchat_xpm;
      ltext = "Free For Chat";
      break;
    case stInvisible:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = private_xpm;
      ltext = "Privacy";
      break;
    case stOffline:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = offline_xpm;
      ltext = "Offline";
      break;
    case stLogin:
      if(timerid==-1)
      {
        picnum = 1;
        lpixmap = connect1_xpm;
        ltext = "Connecting";
        timerid = startTimer(800);
        }
      break;
  }
  update();
}

void PopupButton::timerEvent(QTimerEvent *te)
{

  //this should be changed to an array, but for now it'll do

  if(te->timerId()==timerid)
  {
    picnum++;
    if(picnum>8)
      picnum = 1;

    switch ( picnum )
    {
    	case 1:
 	   	   lpixmap = connect1_xpm;
	       break;
        case 2:
           lpixmap = connect2_xpm;
           break;
        case 3:
           lpixmap = connect3_xpm;
           break;
        case 4:
           lpixmap = connect4_xpm;
           break;
        case 5:
           lpixmap = connect5_xpm;
           break;
        case 6:
           lpixmap = connect6_xpm;
           break;
        case 7:
           lpixmap = connect7_xpm;
           break;
        case 8:
           lpixmap = connect8_xpm;
           break;
  		default:
	   	   lpixmap = connect1_xpm;	 
    }
	emit updateIcon( QPixmap(lpixmap) ); // send off the signal to update the application icon
    update(6, 4, lpixmap.width(), lpixmap.height());

  }
}



