#include <qpainter.h>
#include <qpixmap.h>
#include <qcolor.h>
#include <qtabbar.h>

#include "icqdialogs.h"

#include "pics/message.xpm"
#include "pics/more.xpm"
#include "pics/history.xpm"
#include "pics/url.xpm"
#include "pics/status_away.xpm"
#include "pics/chat.xpm"
#include "pics/info.xpm"
#include "pics/logo.xpm"
#include "pics/userface.xpm"
#include "pics/renameuser.xpm"
#include "pics/addsearch.xpm"

#include "pics/search0.xpm"
#include "pics/search1.xpm"
#include "pics/search2.xpm"
#include "pics/search3.xpm"
#include "pics/search4.xpm"
#include "pics/search5.xpm"
#include "pics/search6.xpm"
#include "pics/search7.xpm"
#include "pics/search8.xpm"
#include "pics/search9.xpm"


// the animated little guy in the corner of the dialogs

AnimatedUserLabel::AnimatedUserLabel(QWidget *parent = 0) : QLabel(parent)
{

   setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
   setAlignment( AlignCenter | AlignCenter );
   setPixmap( QPixmap(search0_xpm));

   picnum = 0;
   timerid = -1;

}               

AnimatedUserLabel::~AnimatedUserLabel()
{
   killTimers();
}

void AnimatedUserLabel::start()
{
   timerid = startTimer(100);
}

void AnimatedUserLabel::stop()
{
   timerid = -1;
   killTimers();
  
}



void AnimatedUserLabel::timerEvent(QTimerEvent *te)
{

  //this should be changed to an array, but for now it'll do

  if(te->timerId()==timerid)
  {
    picnum++;
    if(picnum>9)
      picnum = 0;

    switch ( picnum )
    {
        case 0:
           setPixmap( QPixmap(search0_xpm) );
           break;
        case 1:
           setPixmap( QPixmap(search1_xpm) );
           break;
        case 2:
           setPixmap( QPixmap(search2_xpm) );
           break;
        case 3:
           setPixmap( QPixmap(search3_xpm) );
           break;
        case 4:
           setPixmap( QPixmap(search4_xpm) );
           break;
        case 5:
           setPixmap( QPixmap(search5_xpm) );
           break;
        case 6:
           setPixmap( QPixmap(search6_xpm) );
           break;
        case 7:
           setPixmap( QPixmap(search7_xpm) );
           break;
        case 8:
           setPixmap( QPixmap(search8_xpm) );
           break;
        case 9:
           setPixmap( QPixmap(search9_xpm) );
           break;
        default:
           setPixmap( QPixmap(search0_xpm) );
    }
  }
}




//
// ----messageDialog ---------------------------------------------
//

SendMessageDlg::SendMessageDlg(ICQ *s, ICQUser *u, QWidget *parent = 0, const char *name = 0, bool modal, WFlags f)
: QDialog( parent, name, modal, f )
{
   server = s;
   theUser = u;
   icqEvent = NULL;
   char caption[100];

   setFixedSize(418, 195);
   setIcon(QPixmap(message_xpm));
   sprintf( caption, "Send Message to %s", theUser->alias() );
   setCaption(caption);

   tobox = new QGroupBox("To:",this);
   
   uinline = new QLabel(this);
   uinline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   uinlabel = new QLabel(uinline,"UIN:",this);
   handleline = new QLabel(this);
   handleline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   handlelabel = new QLabel(handleline,"Handle:",this);
   emailline = new QLabel(this);
   emailline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   emaillabel = new QLabel(emailline,"EMail:",this);

   uinlabel->setGeometry (7, 17, 23, 19);
   uinline->setGeometry (35, 15, 60, 19);
	uinline->setAlignment( AlignCenter | AlignCenter );
	uinline->setFont( QFont( "Times", 10 ) );
   
   handlelabel->setGeometry (107, 17, 30, 19);
   handleline->setGeometry (138, 15, 75, 19);
        handleline->setAlignment( AlignCenter | AlignCenter );
        handleline->setFont( QFont( "", 10 ) );
    
   emaillabel->setGeometry (227, 17, 33, 19);
   emailline->setGeometry (264, 15, 125, 19);
        emailline->setAlignment( AlignCenter | AlignCenter );
        emailline->setFont( QFont( "", 10 ) );
 
   uinlabel->setText("UIN:");
   uinline->setText(theUser->uinString()); 
   handlelabel->setText("Nick:");
   handleline->setText(theUser->alias()); 
   emaillabel->setText("Email:");
   emailline->setText(theUser->email()); 


   tobox->setGeometry( 3, 0, width()-6, uinline->height()+20 );



   btnMore = new QPushButton("More", this);
   btnMore->setGeometry(2, 170, 50, 20);
   btnMore->setPixmap( QPixmap(more_xpm) );
   btnMore->setToggleButton( true ); 

   btnMultiple = new QPushButton("Multiple Recipients >>", this);
   btnMultiple->setGeometry(270, 197, 140, 25);
   btnMultiple->setToggleButton( true );

   btnCancel = new QPushButton("Cancel", this);
   btnCancel->setGeometry(60, 165, 90, 25);
   btnCancel->setAccel( Key_Escape );
   btnCancel->setFont( QFont( "", 10 ) );
 
   btnHistory = new QPushButton("Message Dialog", this);
   btnHistory->setGeometry(167, 165, 90, 25);
   btnHistory->setFont( QFont( "", 10 ) );

   btnSend = new QPushButton("Send", this);
   btnSend->setGeometry(275, 165, 90, 25);
   btnSend->setAccel( CTRL+Key_Return );
   btnSend->setFont( QFont( "", 10 ) );
   btnSend->setEnabled(true); 

   btnInfo = new QPushButton(this, "btnInfo");
   btnInfo->setPixmap(QPixmap(info_xpm));
   btnInfo->setGeometry(393,15,18,18);
 
   chkSendServer = new QCheckBox("Send through server", this);
   chkSendServer->setGeometry(5, 198, 150, 20);
   chkSendServer->setChecked(false);

   messagelabel = new QLabel( "Enter Message:", this );
   messagelabel->setGeometry( 5, 42, 95, 15 );

   mleMessage = new MLEditWrap(true, this);
   mleMessage->setGeometry(5, 60, width() - 13, 90);
//   mleMessage->setMaxLength( MAX_MESSAGE_SIZE );
   mleMessage->setAutoUpdate(true);
   mleMessage->repaint();
   mleMessage->setFocus();

   recipientbox = new QGroupBox("Select Recipients",this);
   recipientbox->setFont( QFont( "", 10 ) );
   recipientbox->setGeometry( 424, 0, 96, height()-6 );
   
   recipientList = new QListView(this);
   recipientList->setGeometry( 426, 1, 94, height() - 4 );


   lblAnimation = new AnimatedUserLabel(this);
   lblAnimation->setGeometry(374,154,36,36);


   connect( btnMore, SIGNAL(clicked()), this, SLOT(clickMore()) );
   connect( btnCancel, SIGNAL(clicked()), this, SLOT(clickCancel()) );
   connect( btnHistory, SIGNAL(clicked()), this, SLOT(showHistory()) );
   connect( btnInfo, SIGNAL(clicked()), this, SLOT(showInfo()) );
   connect( btnSend, SIGNAL(clicked()), this, SLOT(sendMessage()) );
   connect (server, SIGNAL(doneUserFcn(bool, ICQEvent *)), this, SLOT(doneSend(bool, ICQEvent *)));
   connect( chkSendServer, SIGNAL(clicked()), this, SLOT(clickSndServer()) );
   connect( btnMultiple, SIGNAL(clicked()), this, SLOT(clickMultiple()) );

}

void SendMessageDlg::show()
{
   char caption[100];

   mleMessage->setText("");

   if (theUser->status() == ICQ_STATUS_OFFLINE)
   {
      chkSendServer->setChecked(true);
      chkSendServer->setEnabled(false);
   }
   else
   {
//   theUser->setSendServer(chkSendServer->isChecked());
   chkSendServer->setChecked(theUser->sendServer());
   }

   if (chkSendServer->isChecked())
   {
      sprintf( caption, "Send Message through server to %s", theUser->alias() );
      setCaption(caption);
   }

   QDialog::show();
}
 
void SendMessageDlg::clickMore( void )
{
   if (btnMore->isOn()) {
      setFixedSize(418, 225);
   } else {
      setFixedSize(418, 195);
      btnMultiple->setOn(false);
   }
}

void SendMessageDlg::clickCancel( void )
{
   if (!btnSend->isEnabled())
   {
      btnSend->setEnabled(true);
      mleMessage->setEnabled(true);
      if (icqEvent != NULL) server->cancelEvent(icqEvent);
      lblAnimation->stop();
   } else hide();

}

void SendMessageDlg::clickMultiple( void )
{
   if (btnMultiple->isOn()) {
      setFixedSize(528, 225);
      setupMultipleMessages();
   } else {
      setFixedSize(418, 225);
   }

}

void SendMessageDlg::clickSndServer( void )
{
   char caption[100];

   if (chkSendServer->isChecked())
   {
      sprintf( caption, "Send Message through server to %s", theUser->alias() );
   } else {
      sprintf( caption, "Send Message to %s", theUser->alias() );
   }
   setCaption(caption);
 
}

void SendMessageDlg::sendMessage( void )
{
   char msg[1024]; // maybe this should go higher or lower?
   unsigned long uin; 

   sprintf(msg, "%s", (const char *)mleMessage->text());

   btnSend->setEnabled(false);
   mleMessage->setEnabled(false);


    //uin = (chkSpoof->isChecked() ? atoi(edtSpoof->text()) : server->icqOwner.uin());
   uin = server->icqOwner.uin();

   lblAnimation->start();

   if ((icqEvent = server->sendMessage(theUser, msg, (chkSendServer->isChecked() ? false : true), uin)) == NULL)
            doneSend(false, NULL);
 
 
//   server->sendMessage(theUser, msg, (chkSendServer->isChecked() ? false : true), uin);

   //chkSendServer->setChecked(theUser->sendServer());
   theUser->setSendServer(chkSendServer->isChecked());
}

void SendMessageDlg::showHistory( void )
{
   if (theUser->historyDlg == NULL)
   {
      theUser->historyDlg = new HistoryDlg(theUser); 
      connect (theUser->historyDlg, SIGNAL(finished(ICQUser *, int)), this, SLOT(enableHistoryBtn()) );
      theUser->historyDlg->show();
      btnHistory->setEnabled(false); 
   }
}

void SendMessageDlg::showInfo( void )
{
   if (theUser->infoDlg == NULL)
   {
      theUser->infoDlg = new UserInfoDlg(server, theUser);
      theUser->infoDlg->show();
   }
}

void SendMessageDlg::hide()
{
   QDialog::hide();
   
   //theUser->setSendServer(chkSendServer->isChecked());

   emit finished(theUser, 0);
   //emit killIt();
}

void SendMessageDlg::doneSend(bool isOk, ICQEvent *e)
{
   if (e != icqEvent) return;

   unsigned short theCmd = 0;
   if (e != NULL) theCmd = e->cmd;
   icqEvent = NULL;

   if (isOk)
   {
/*      if (theCmd == ICQ_CMDxTCP_START
          && theUser->status() != ICQ_STATUS_ONLINE
          && theUser->status() != ICQ_STATUS_PRIVATE
          && theUser->status() != ICQ_STATUS_OFFLINE
          && theUser->status() != ICQ_STATUS_FREEFORCHAT)
      {
	// show away message 
      }
      else */
         hide();
   }
}

void SendMessageDlg::enableHistoryBtn()
{
   btnHistory->setEnabled(true);
}

void SendMessageDlg::setMoreClicked( bool value )
{
   if (value) {
      setFixedSize(418, 225);
   } else {
      setFixedSize(418, 195);
      btnMultiple->setOn(false);
   }
}

void SendMessageDlg::setMultipleClicked( bool )
{

}

void SendMessageDlg::setupMultipleMessages( void )
{
   unsigned short i;

   recipientList->clear();

   for (i = 0; i < server->users.size(); i++)
   {
//      (void) new QCheckListItem(recipientList, server->users[i], CheckBox); 
   }
}

void SendMessageDlg::killMe( void )
{
   theUser->messageDlg = NULL;
   delete this;
}

//
// ----historyDialog ---------------------------------------------
//

HistoryDlg::HistoryDlg(ICQUser *u, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   theUser = u;
   char caption[50];

   setFixedSize( 522, 252 );
   setIcon(QPixmap(history_xpm));
   sprintf(caption, "History Events Of : %s", theUser->alias());
   setCaption( caption );

   btnCancel = new QPushButton("Close", this);
   btnCancel->setGeometry(5, height() - 30, 62, 22);
   btnCancel->setAccel( Key_Escape );
   btnCancel->setFont( QFont( "", 10 ) );
 
   btnDeleteAll = new QPushButton("Delete Log", this);
   btnDeleteAll->setGeometry(452, height() - 30, 62, 22);
   btnDeleteAll->setFont( QFont( "", 10 ) );


   mleHistory = new MLEditWrap(true, this);
   mleHistory->setGeometry(5, 5, width() - 13, height() - 40);
   mleHistory->setReadOnly(true);

   connect( btnCancel, SIGNAL(clicked()), this, SLOT(hide()) );
   connect( btnDeleteAll, SIGNAL(clicked()), this, SLOT(deleteAll()) );
}

void HistoryDlg::show()
{
   mleHistory->setText("");
   showHistory();
   QDialog::show();
}
 
void HistoryDlg::deleteAll()
{
   char message[50];

   sprintf( message, "Delete your message history for %s?", theUser->alias() );
   if (theUser->history != NULL)
   {
      if( QMessageBox::warning( this, "ICQnix", message, QMessageBox::Ok, QMessageBox::Cancel) == 1) 
      {
         theUser->history->close();
         theUser->history->open(IO_WriteOnly);
         mleHistory->setText("");
         theUser->history->writeBlock((const char *)mleHistory->text(), strlen((const char *)mleHistory->text()) );
//         theUser->history->writeBlock(NULL, 0 );
         theUser->history->close();
         theUser->history->open(IO_Append | IO_WriteOnly);
      }
   }

}
 
void HistoryDlg::showHistory()
{
   char *buf;
   if (theUser->history != NULL)
   {
      theUser->history->close();
      if (!theUser->history->open(IO_ReadOnly))  // a serious error occured
      {
         mleHistory->setText("History is having problems: ");
         mleHistory->append(theUser->history->name());
         theUser->history->open(IO_Append | IO_WriteOnly);
         return;
      }
      int historyLen = theUser->history->size();
      buf = new char[historyLen + 1];
      theUser->history->readBlock(buf, historyLen);
      buf[historyLen] = '\0';
      mleHistory->setText(buf);
      delete buf;
      theUser->history->close();
      theUser->history->open(IO_Append | IO_WriteOnly);
   }
}

void HistoryDlg::hide()
{
   QDialog::hide();
   //delete this;

// this needs to be fixed ?

   //if (icqEvent != NULL) server->cancelEvent(icqEvent);
   emit finished(theUser, 6);
   
   theUser->historyDlg = NULL;
   delete this;
}

//
// ----ReadMessageDialog ---------------------------------------------
//

ReadMsgDlg::ReadMsgDlg(ICQ *s, ICQUser *u, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   server = s;
   theUser = u;
   char caption[100];

   setFixedSize( 390, 250 );
   setIcon(QPixmap(message_xpm));
   sprintf( caption, "Incoming Message from %s", theUser->alias() );
   setCaption(caption);

   frombox = new QGroupBox("From:",this);
   
   uinline = new QLabel(this);
   uinline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   uinlabel = new QLabel(uinline,"UIN:",this);
   handleline = new QLabel(this);
   handleline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   handlelabel = new QLabel(handleline,"Handle:",this);
   emailline = new QLabel(this);
   emailline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   emaillabel = new QLabel(emailline,"EMail:",this);
//   dateline = new QLabel(this);
//   dateline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
//   datelabel = new QLabel(dateline,"Date:",this);
   timeline = new QLabel(this);
   timeline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   timelabel = new QLabel(timeline,"Time:",this);



   handlelabel->setGeometry (7, 15, 43, 19);
        handlelabel->setFont( QFont( "Times", 12 ) );
   handleline->setGeometry (51, 14, 70, 19);
        handleline->setAlignment( AlignCenter | AlignCenter );
        handleline->setFont( QFont( "", 10 ) );

   emaillabel->setGeometry (130, 15, 35, 19);
        emaillabel->setFont( QFont( "Times", 12 ) );
   emailline->setGeometry (171, 14, 190, 19);
        emailline->setAlignment( AlignCenter | AlignCenter );
        emailline->setFont( QFont( "", 10 ) );

   uinlabel->setGeometry (7, 39, 25, 19);
	uinlabel->setFont( QFont( "Times", 12 ) );
   uinline->setGeometry (51, 38, 70, 19);
	uinline->setAlignment( AlignCenter | AlignCenter );
	uinline->setFont( QFont( "Times", 10 ) );

//   datelabel->setGeometry (130, 39, 27, 19);
//        datelabel->setFont( QFont( "Times", 12 ) );
//   dateline->setGeometry (171, 38, 75, 19);
//        dateline->setAlignment( AlignCenter | AlignCenter );
//        dateline->setFont( QFont( "", 10 ) );

//   timelabel->setGeometry (260, 39, 27, 19);
   timelabel->setGeometry (130, 39, 27, 19);
        timelabel->setFont( QFont( "Times", 12 ) );
//   timeline->setGeometry (298, 38, 85, 19);
   timeline->setGeometry ( 171, 38, 120,  19 );
        timeline->setAlignment( AlignCenter | AlignCenter );
        timeline->setFont( QFont( "Times", 10 ) );
   

   uinline->setText(theUser->uinString()); 
   handleline->setText(theUser->alias()); 
   emailline->setText(theUser->email());


   frombox->setGeometry( 0, 0, width()-1, uinline->height()+45 );

   messagebox = new QGroupBox("Message", this);
   mleRead = new MLEditWrap(true, this);
   mleRead->setGeometry(5, 80, width() - 13, 78);
//   mleRead->setBackgroundColor(backgroundColor);
   mleRead->setAutoUpdate(true);
   mleRead->setFocus();

   messagebox->setGeometry( 0, 65, width()-1, 146 );
 

   responsebox = new QGroupBox("Response Action", this);

   btnReply = new QPushButton("Reply", this);
   btnReply->setGeometry(10, 177, 76, 24);
   btnReply->setFont( QFont( "", 10 ) );

   btnForward = new QPushButton("Forward", this);
   btnForward->setGeometry(91, 177, 90, 24);
   btnForward->setFont( QFont( "", 10 ) );
 
   btnHistory = new QPushButton("Message Dialog", this);
   btnHistory->setGeometry(187, 177, 90, 24);
   btnHistory->setFont( QFont( "", 10 ) );

   btnRequest = new QPushButton("Request Chat", this);
   btnRequest->setGeometry(287, 177, 90, 24);
   btnRequest->setFont( QFont( "", 10 ) );

   btnClose = new QPushButton("Close", this);
   btnClose->setGeometry(255, 223, 54, 25);
   btnClose->setAccel( Key_Escape );
   btnClose->setFont( QFont( "", 10 ) );

   btnNext = new QPushButton("Read Next", this);
   btnNext->setGeometry(316, 223, 69, 25);
   btnNext->setAccel( CTRL+Key_Return );
   btnNext->setFont( QFont( "", 10 ) );


   responsebox->setGeometry( 3, 159, width()-9, btnReply->height()+24 );

   connect( btnClose, SIGNAL(clicked()), this, SLOT(clickClose()) );
   connect( btnNext, SIGNAL(clicked()), this, SLOT(readNext()) );
   connect( btnReply, SIGNAL(clicked()), this, SLOT(reply()) );
   connect( btnForward, SIGNAL(clicked()), this, SLOT(forward()) );
   connect( btnHistory, SIGNAL(clicked()), this, SLOT(showHistory()) );
   connect( btnRequest, SIGNAL(clicked()), this, SLOT(requestChat()) );
   connect( server, SIGNAL(doneUserFcn(bool, ICQEvent *)), this, SLOT(doneChatRequest(bool, ICQEvent *)) );
   connect( server, SIGNAL(updatedUsers()), this, SLOT(incomingMessage()) );

}

void ReadMsgDlg::show()
{
   mleRead->setText("");
   mleRead->setReadOnly(true);

   readMessage();
   mleRead->repaint();

   QDialog::show();
}
 
void ReadMsgDlg::readMessage( void )
{

   if (theUser->numMessages() > 1 ) // more messages
      btnNext->setEnabled(true);
   else
      btnNext->setEnabled(false);


   Message *m;
   m = theUser->getMessage(0);

//   dateline->setText( m->timeRec() );
   timeline->setText( m->timeRec() );
 

   char theMsg[strlen(m->msg()) + 128];
   sprintf(theMsg, "%s", m->msg());
   
   mleRead->clear();
   mleRead->append(theMsg);
   mleRead->update();

   if (m->cmd() == ICQ_CMDxTCP_START && m->subCmd() == ICQ_CMDxTCP_CHAT)
   {
      // accept or refuse the chat request
      unsigned short chatResult = QMessageBox::information(this, "ICQnix", "Accept or refuse chat request here.", "Accept", "Refuse", "Ignore");
      if (chatResult == 1)
         server->chatRefuse(theUser, "chat request refused", m->sequence());
      else if (chatResult == 0)
      {
//         unsigned short port;
//         if (server->tcpServerPort != 0)   // assign the chat port
//         {
//            unsigned short i = 0;
//            while (i < 10 && server->tcpPorts[i]) i++;
//            port = server->tcpServerPort + i + 1;
//            server->tcpPorts[i] = true;
//         }
//         else port = 0;
         ChatDlg *chatDlg = new ChatDlg(theUser, &(server->icqOwner), true);
         server->chatAccept(theUser, chatDlg->port(), m->sequence());
         chatDlg->show();
      }
   }

   theUser->clearMessage(0);
   emit updatedUsers();

}

void ReadMsgDlg::incomingMessage( void )
{
   if (theUser->numMessages() > 0 )
      btnNext->setEnabled(true);
   else 
      btnNext->setEnabled(false);
}

void ReadMsgDlg::showHistory( void )
{
   if (theUser->historyDlg == NULL)
   {
      theUser->historyDlg = new HistoryDlg(theUser);
      connect (theUser->historyDlg, SIGNAL(finished(ICQUser *, int)), this, SLOT(enableHistoryBtn()) );  
      theUser->historyDlg->show();
      btnHistory->setEnabled(false);
   }
}

void ReadMsgDlg::readNext()
{
   readMessage();
}

void ReadMsgDlg::reply()
{
   if (theUser->messageDlg == NULL)
   {
       theUser->messageDlg = new SendMessageDlg(server, theUser);
       theUser->messageDlg->show();
       btnReply->setEnabled(false);

       if (theUser->numMessages() < 1 )
          emit finished(theUser, 99);
       else
          connect (theUser->messageDlg, SIGNAL(finished(ICQUser*, int)), this, SLOT(enableReplyBtn()) ); 

       connect (theUser->messageDlg, SIGNAL(finished(ICQUser *, int)), theUser->messageDlg, SLOT(killMe()) );
    }
}

void ReadMsgDlg::forward()
{
   char *msg, *tmp;

   if (theUser->messageDlg == NULL)
   {
       theUser->messageDlg = new SendMessageDlg(server, theUser);
       theUser->messageDlg->show();
       connect (theUser->messageDlg, SIGNAL(finished(ICQUser *, int)), theUser->messageDlg, SLOT(killMe()) );

       btnForward->setEnabled(false);
       mleRead->text();
       
       tmp = new char[strlen(mleRead->text()) + 1];
       strcpy( tmp, mleRead->text() );
       msg = new char[strlen(tmp) + strlen(theUser->alias()) + strlen(" Wrote:\n")+1];
       sprintf(msg, "%s Wrote:\n%s", theUser->alias(), tmp );

       theUser->messageDlg->mleMessage->setText(msg);	

       if (theUser->numMessages() < 1 )
          emit finished(theUser, 99);
   }

}

void ReadMsgDlg::doneChatRequest(bool isOk, ICQEvent *e)
{
   if (e != icqEvent) return;

   unsigned short theCmd = 0;
   if (e != NULL) theCmd = e->cmd;
   icqEvent = NULL;

   if (isOk)
   {
/*      if (theCmd == ICQ_CMDxTCP_START
          && theUser->status() != ICQ_STATUS_ONLINE
          && theUser->status() != ICQ_STATUS_PRIVATE
          && theUser->status() != ICQ_STATUS_OFFLINE
          && theUser->status() != ICQ_STATUS_FREEFORCHAT)
      {
	// show away message 
      }
      else */
         hide();
   }
}

void ReadMsgDlg::requestChat()
{
   if (theUser->chatReqDlg == NULL)
   {
      theUser->chatReqDlg = new ChatRequestDlg(server, theUser);
      theUser->chatReqDlg->show();
      connect (theUser->chatReqDlg, SIGNAL(finished(ICQUser *, int)), this, SLOT(killChatRequestDlg(ICQUser *, int)) );
      clickClose();
   }
}

void ReadMsgDlg::clickClose()
{
   emit finished(theUser, 99);
   close();
}

void ReadMsgDlg::killWindow(ICQUser *u, int window)
{
   if ((window == 0) && (u->messageDlg != NULL))
   {
      delete u->messageDlg;
      u->messageDlg = NULL;
      btnReply->setEnabled(true); 
      btnForward->setEnabled(true);
      emit finished(theUser, 99);
      close();
   }
}

void ReadMsgDlg::killChatRequestDlg(ICQUser *u, int window)
{
   if ((window == MENU_CHAT_REQUEST) && (u->chatReqDlg != NULL))
   {
      delete u->chatReqDlg;
      u->chatReqDlg = NULL;
      btnRequest->setEnabled(true);
   }
}

void ReadMsgDlg::enableHistoryBtn()
{
   btnHistory->setEnabled(true);
}

void ReadMsgDlg::enableReplyBtn()
{
   btnReply->setEnabled(true);
}



//
// ----SendURLDlg ---------------------------------------------
//

SendURLDlg::SendURLDlg(ICQ *s, ICQUser *u, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   server = s;
   theUser = u;
   icqEvent = NULL;
   char caption[100];

   setFixedSize( 323, 220 );
   setIcon(QPixmap(url_xpm));
   sprintf( caption, "Send URL to %s", theUser->alias() );
   setCaption(caption);

   tobox = new QGroupBox("To:",this);
   
   uinline = new QLabel(this);
   uinline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   uinlabel = new QLabel(uinline,"UIN:",this);
   handleline = new QLabel(this);
   handleline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   handlelabel = new QLabel(handleline,"Handle:",this);
   emailline = new QLabel(this);
   emailline->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   emaillabel = new QLabel(emailline,"EMail:",this);

   uinlabel->setGeometry (14, 17, 23, 19);
   uinline->setGeometry (42, 15, 85, 19);
	uinline->setAlignment( AlignCenter | AlignCenter );
	uinline->setFont( QFont( "Times", 10 ) );
   
   handlelabel->setGeometry (137, 17, 30, 19);
   handleline->setGeometry (170, 15, 135, 19);
        handleline->setAlignment( AlignCenter | AlignCenter );
        handleline->setFont( QFont( "", 10 ) );
    
   emaillabel->setGeometry (7, 40, 33, 19);
   emailline->setGeometry (42, 38, 240, 19);
        emailline->setAlignment( AlignCenter | AlignCenter );
        emailline->setFont( QFont( "", 10 ) );
 
   uinlabel->setText("UIN:");
   uinline->setText(theUser->uinString()); 
   handlelabel->setText("Nick:");
   handleline->setText(theUser->alias()); 
   emaillabel->setText("Email:");
   emailline->setText(theUser->email()); 


   tobox->setGeometry( 3, 0, width()-6, uinline->height()+43 );



   btnMore = new QPushButton("More", this);
   btnMore->setGeometry(2, 193, 53, 20);
   btnMore->setPixmap( QPixmap(more_xpm) );
   btnMore->setToggleButton( true ); 

   btnCancel = new QPushButton("Cancel", this);
   btnCancel->setGeometry(60, 188, 90, 25);
   btnCancel->setAccel( Key_Escape );
   btnCancel->setFont( QFont( "", 10 ) );
 
   btnSend = new QPushButton("Send", this);
   btnSend->setGeometry(185, 188, 90, 25);
   btnSend->setAccel( CTRL+Key_Return );
   btnSend->setFont( QFont( "", 10 ) );
   btnSend->setEnabled(true); 
 
   btnInfo = new QPushButton(this, "btnInfo");
   btnInfo->setPixmap(QPixmap(info_xpm));
   btnInfo->setGeometry(287,38,18,18);
 

   chkSendServer = new QCheckBox("Send through server", this);
   chkSendServer->setGeometry(5, 227, 150, 20);
   chkSendServer->setChecked(false);


   urllabel = new QLabel( "Enter URL:", this );
   urllabel->setGeometry( 5, 65, 130, 15 );
 
   edtURL = new QLineEdit(this);
   edtURL->setGeometry(5, 82, width() - 13, 20);

   messagelabel = new QLabel( "Enter URL Description:", this );
   messagelabel->setGeometry( 5, 108, 130, 15 );

   mleMessage = new MLEditWrap(true, this);
   mleMessage->setGeometry(5, 125, width() - 13, 47);

   edtURL->setFocus();


   lblAnimation = new AnimatedUserLabel(this);
   lblAnimation->setGeometry(279,177,36,36);


   connect( btnMore, SIGNAL(clicked()), this, SLOT(clickMore()) );
   connect( btnCancel, SIGNAL(clicked()), this, SLOT(clickCancel()) );
   connect( btnSend, SIGNAL(clicked()), this, SLOT(sendURL()) );
   connect( btnInfo, SIGNAL(clicked()), this, SLOT(showInfo()) );
   connect (server, SIGNAL(doneUserFcn(bool, ICQEvent *)), this, SLOT(doneSend(bool, ICQEvent *)));
   connect( chkSendServer, SIGNAL(clicked()), this, SLOT(clickSndServer()) );

}

void SendURLDlg::show()
{
   char caption[100];

   mleMessage->setText("");

   if (theUser->status() == ICQ_STATUS_OFFLINE)
   {
      chkSendServer->setChecked(true);
      chkSendServer->setEnabled(false);
   }
   else
   {
//   theUser->setSendServer(chkSendServer->isChecked());
   chkSendServer->setChecked(theUser->sendServer());
   }

   if (chkSendServer->isChecked())
   {
      sprintf( caption, "Send URL through server to %s", theUser->alias() );
      setCaption(caption);
   }

   QDialog::show();
}
 
void SendURLDlg::clickMore( void )
{
   if (btnMore->isOn()) {
      setFixedSize( 323, 255);
   } else {
      setFixedSize( 323, 220 );
   }
}

void SendURLDlg::clickSndServer( void )
{
   char caption[100];

   if (chkSendServer->isChecked())
   {
      sprintf( caption, "Send URL through server to %s", theUser->alias() );
   } else {
      sprintf( caption, "Send URL to %s", theUser->alias() );
   }
   setCaption(caption);
 
}

void SendURLDlg::sendURL( void )
{
   char msg[1024]; // maybe this should go higher or lower?
   unsigned long uin; 

   sprintf(msg, "%s", (const char *)mleMessage->text());

   btnSend->setEnabled(false);
   edtURL->setEnabled(false);
   mleMessage->setEnabled(false);


    //uin = (chkSpoof->isChecked() ? atoi(edtSpoof->text()) : server->icqOwner.uin());
   uin = server->icqOwner.uin();
   
   lblAnimation->start();

   if ((icqEvent = server->sendUrl(theUser, (char *)edtURL->text(), msg, (chkSendServer->isChecked() ? false : true), uin)) == NULL)
      doneSend(false, NULL);

   //chkSendServer->setChecked(theUser->sendServer());
   theUser->setSendServer(chkSendServer->isChecked());
}

void SendURLDlg::showInfo( void )
{
   if (theUser->infoDlg == NULL)
   {
      theUser->infoDlg = new UserInfoDlg(server, theUser);
      theUser->infoDlg->show();
   }
}


void SendURLDlg::hide()
{
   QDialog::hide();
   
   //theUser->setSendServer(chkSendServer->isChecked());

   if (icqEvent != NULL) server->cancelEvent(icqEvent);
   
   emit finished(theUser, 2);
}

void SendURLDlg::doneSend(bool isOk, ICQEvent *e)
{
   if (e != icqEvent) return;

   unsigned short theCmd = 0;
   if (e != NULL) theCmd = e->cmd;
   icqEvent = NULL;

   if (isOk)
   {
/*      if (theCmd == ICQ_CMDxTCP_START
          && theUser->status() != ICQ_STATUS_ONLINE
          && theUser->status() != ICQ_STATUS_PRIVATE
          && theUser->status() != ICQ_STATUS_OFFLINE
          && theUser->status() != ICQ_STATUS_FREEFORCHAT)
      {
	// show away message 
      }
      else */
         hide();
   }
}

void SendURLDlg::clickCancel( void )
{
   if (!btnSend->isEnabled())
   {
      btnSend->setEnabled(true);
      edtURL->setEnabled(true);
      mleMessage->setEnabled(true);
      //if (icqEvent != NULL) server->cancelEvent(icqEvent);
      lblAnimation->stop();
   } else hide();

}


//
// ----ChatReqDialog ---------------------------------------------
//

ChatRequestDlg::ChatRequestDlg(ICQ *s, ICQUser *u, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   server = s;
   theUser = u;
   icqEvent = NULL;

   char caption[50];

   setIcon(QPixmap(chat_xpm));
   sprintf(caption, "Send Chat Request to %s", theUser->alias());
   setCaption( caption );
   setFixedSize(354,172);
   setStyle(WindowsStyle);

   tobox = new QGroupBox("To:",this);

   label1 = new QLabel(this, "label1");
   label1->setText("Enter Chat Subject:");
   label1->setAlignment(AlignLeft | AlignTop);
   label1->setGeometry(8,66,121,15);
   label1->setFont( QFont( "", 10 ) );

   label2 = new QLabel(this, "label2");
   label2->setText("ICQ#:");
   label2->setAlignment(AlignLeft | AlignTop);
   label2->setGeometry(11,15,33,14);
   label2->setFont( QFont( "", 10 ) );

   label3 = new QLabel(this, "label3");
   label3->setText("EMail:");
   label3->setAlignment(AlignLeft | AlignTop);
   label3->setGeometry(10,38,30,16);
   label3->setFont( QFont( "", 10 ) );

   label4 = new QLabel(this, "label4");
   label4->setText("Nick");
   label4->setAlignment(AlignLeft | AlignTop);
   label4->setGeometry(175,15,27,14);
   label4->setFont( QFont( "", 10 ) );

   lblEmail = new QLabel(this, "lblEmail");
   lblEmail->setAlignment( AlignCenter | AlignCenter );;
   lblEmail->setGeometry(46,38,271,18);
   lblEmail->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   lblEmail->setFont( QFont( "", 10 ) );

   lblICQNumber = new QLabel(this, "lblICQNumber");
   lblICQNumber->setAlignment( AlignCenter | AlignCenter );;
   lblICQNumber->setGeometry(47,15,94,17);
   lblICQNumber->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   lblICQNumber->setFont( QFont( "", 10 ) );

   lblNickname = new QLabel(this, "lblNickname");
   lblNickname->setAlignment( AlignCenter | AlignCenter );
   lblNickname->setGeometry(209,15,129,17);
   lblNickname->setFrameStyle(QFrame::Panel | QFrame::Sunken);
   lblNickname->setFont( QFont( "", 10 ) );


   lblICQNumber->setText(theUser->uinString());
   lblNickname->setText(theUser->alias());
   lblEmail->setText(theUser->email());

   tobox->setGeometry( 3, 0, width()-6, lblEmail->height()+47 ); 


   btnCancel = new QPushButton(this, "btnCancel");
   btnCancel->setText("Cancel");
   btnCancel->setGeometry(7,141,60,26);
   btnCancel->setFont( QFont( "", 10 ) );
   btnCancel->setAccel( Key_Escape );

   btnChat = new QPushButton(this, "btnChat");
   btnChat->setText("Chat");
   btnChat->setDefault(true);
   btnChat->setGeometry(229,141,73,26);
   btnChat->setFont( QFont( "", 10 ) );

   btnJoin = new QPushButton(this, "btnJoin");
   btnJoin->setText("Join Session");
   btnJoin->setEnabled(false);
   btnJoin->setGeometry(149,141,71,26);
   btnJoin->setFont( QFont( "", 10 ) );

   btnInfo = new QPushButton(this, "btnInfo");
   btnInfo->setPixmap(QPixmap(info_xpm));
   btnInfo->setGeometry(320,38,18,18);


   mleSubject = new QMultiLineEdit(this, "mleSubject");
   mleSubject->setGeometry(7,82,334,46);
   mleSubject->setFocus();

   lblAnimation = new AnimatedUserLabel(this);
   lblAnimation->setGeometry(305,131,36,36);

   connect( btnCancel, SIGNAL(clicked()), this, SLOT(clickCancel()) );
   connect( btnInfo, SIGNAL(clicked()), this, SLOT(showInfo()) );
   connect( btnChat, SIGNAL(clicked()), this, SLOT(requestChat()) );
   connect (server, SIGNAL(doneUserFcn(bool, ICQEvent *)), this, SLOT(doneChatRequest(bool, ICQEvent *)));

}

void ChatRequestDlg::show()
{
   QDialog::show();
}

void ChatRequestDlg::requestChat()
{
   char msg[1024];
   unsigned long uin;

   mleSubject->setEnabled(false);
   btnChat->setEnabled(false);
   lblAnimation->start();

   sprintf(msg, "%s", (const char *)mleSubject->text());

   uin = server->icqOwner.uin();

   if ((icqEvent = server->sendChat(theUser, msg, true, uin)) == NULL) 
      doneChatRequest(false, NULL);
//    server->sendChat(theUser, msg, (theUser->sendServer() ? false : true), uin);

//   server->sendChat(theUser, msg, true, uin);

}

void ChatRequestDlg::showInfo( void )
{
   if (theUser->infoDlg == NULL)
   {
      theUser->infoDlg = new UserInfoDlg(server, theUser);
      theUser->infoDlg->show();
   }
}

void ChatRequestDlg::clickCancel()
{

   if (!btnChat->isEnabled())
   {
      btnChat->setEnabled(true);
      mleSubject->setEnabled(true);
      if (icqEvent != NULL) server->cancelEvent(icqEvent);
      lblAnimation->stop();
   } else hide();
}

void ChatRequestDlg::hide()
{
   QDialog::hide();
   //delete this;

   //if (icqEvent != NULL) server->cancelEvent(icqEvent);
   emit finished(theUser, 4);
}
   

void ChatRequestDlg::doneChatRequest(bool isOk, ICQEvent *e)
{
   if (e != icqEvent) return;

   unsigned short theCmd = 0;
   if (e != NULL) theCmd = e->cmd;
   icqEvent = NULL;

   if (isOk) hide();

}


//
// ----ReadAwayMsgDialog ---------------------------------------------
//

ReadAwayMsgDlg::ReadAwayMsgDlg(ICQ *s, ICQUser *u, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   server = s;          
   theUser = u;
   char caption[50];

   setFixedSize( 300, 150 );
   setIcon(QPixmap(away_xpm));
   sprintf(caption, "Read Away Message For %s", theUser->alias());
   setCaption( caption );


   mleAwayMsg = new MLEditWrap(true, this);
   mleAwayMsg->setReadOnly(true);
   mleAwayMsg->setGeometry(10, 15, 280, 95);


   btnUpdate = new QPushButton("Update", this);
   btnUpdate->setGeometry(10, 120, 90, 25);
   btnUpdate->setAccel( Key_Escape );
   btnUpdate->setFont( QFont( "", 10 ) );

   btnCancel = new QPushButton("Close", this);
   btnCancel->setGeometry(200, 120, 90, 25);
   btnCancel->setAccel( Key_Escape );
   btnCancel->setFont( QFont( "", 10 ) );


//   server->sendReadAwayMsg( theUser, true, server->icqOwner.uin() );
//
//   struct UserStatusline us;
//   theUser->getStatusInfo(us);
//   mleAwayMsg->setText( us.awayMessage );
   
   connect( btnUpdate, SIGNAL(clicked()), this, SLOT(update()) );
   connect( btnCancel, SIGNAL(clicked()), this, SLOT(hide()) );
}

void ReadAwayMsgDlg::show()
{
   QDialog::show();
}


void ReadAwayMsgDlg::hide()
{
   QDialog::hide();
   //delete this;

// this needs to be fixed ?

   //if (icqEvent != NULL) server->cancelEvent(icqEvent);
   emit finished(theUser, 7);
}

void ReadAwayMsgDlg::update()
{
   struct UserStatusline us;

   server->sendReadAwayMsg( theUser, true, server->icqOwner.uin() );

   theUser->getStatusInfo(us);
   mleAwayMsg->setText( us.awayMessage );
}



//
// ----AwayMessageDialog ---------------------------------------------
//


AwayMessageDlg::AwayMessageDlg(ICQUser *u, QWidget *parent, char *name)
        : QDialog(parent,name,FALSE,WStyle_Customize | WStyle_NormalBorder)
{
   setCaption("Away Message");
   setFixedSize(320,150);
   setIcon(QPixmap(away_xpm));

   btnOK = new QPushButton(this, "btnOK");
   btnOK->setText("OK");
   btnOK->setGeometry(219,118,98,26);
   btnOK->setFont( QFont( "", 10 ) );
   btnOK->setDefault(true);
   btnOK->setAccel( Key_Escape );

   btnMessage = new QPushButton(this, "btnMessage");
   btnMessage->setText("Leave a Message");
   btnMessage->setGeometry(5,118,104,27);
   btnMessage->setFont( QFont( "", 10 ) );

   check1 = new QCheckBox(this, "check1");
   check1->setText("Don't show again");
   check1->setGeometry(112, 123, 107, 17);
   check1->setFont( QFont( "", 10 ) );

   label2 = new QLabel(this, "label2");
   label2->setAlignment(AlignLeft | AlignTop);
   label2->setGeometry(7,3,18,32);
   label2->setPixmap(QPixmap(userface_xpm));

   label3 = new QLabel(this, "label3");
   label3->setText("User is away");
   label3->setAlignment(AlignLeft | AlignTop);
   label3->setGeometry(117,30,90,15);

   label1 = new QLabel(this, "label1");
   label1->setText("User is in Away Mode");
   label1->setAlignment(AlignLeft | AlignTop);
   label1->setGeometry(54,6,129,15);

   mlined1 = new QMultiLineEdit(this, "mlined1");
   mlined1->setGeometry(4,48,311,63);
   mlined1->setReadOnly(TRUE);
   mlined1->setPalette(QPalette(
     QColorGroup(QColor(0,0,0), QColor(255,255,255),
     QColor(255,255,255),QColor(96,96,96),QColor(160,160,160),
     QColor(0,0,0),QColor(255,255,255)),
     QColorGroup(QColor(128,128,128), QColor(192,192,192),
     QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
     QColor(128,128,128),QColor(192,192,192)),
     QColorGroup(QColor(0,0,0), QColor(192,192,192),
     QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
     QColor(0,0,0),QColor(255,255,255))));

   
   connect( btnOK, SIGNAL(clicked()), this, SLOT(hide()));

}



//
// ----AboutBox Dialog ---------------------------------------------
//

AboutDlg::AboutDlg(QWidget *parent, char *name)
        : QDialog(parent,name,FALSE,WStyle_Customize | WStyle_DialogBorder)
{
   setCaption("About ICQnix");
   setFixedSize(294,191);

   label1 = new QLabel(this, "label1");
   label1->setPixmap(QPixmap(logo_xpm));
   label1->setAlignment(AlignLeft | AlignTop);
   label1->setGeometry(3,3,102,163);

   lblTitle = new QLabel(this, "lblTitle");
   lblTitle->setText("ICQnix");
   lblTitle->setFont(QFont("times",26,QFont::Bold,(int)1));
   lblTitle->setAlignment(AlignLeft | AlignTop);
   lblTitle->setGeometry(133,3,97,33);
   lblTitle->setPalette(QPalette(
     QColorGroup(QColor(0,0,0), QColor(192,192,192),
     QColor(255,255,255),QColor(96,96,96),QColor(160,160,160),
     QColor(0,0,255),QColor(255,255,255)),
     QColorGroup(QColor(128,128,128), QColor(192,192,192),
     QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
     QColor(128,128,128),QColor(192,192,192)),
     QColorGroup(QColor(0,0,0), QColor(192,192,192),
     QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
     QColor(0,0,0),QColor(255,255,255))));

   lblAuthor = new QLabel(this, "lblAuthor");
   lblAuthor->setText("by Jacob M. Ciango");
   lblAuthor->setAlignment(AlignLeft | AlignTop);
   lblAuthor->setFont(QFont( "Times", 10 ));
   lblAuthor->setGeometry(133,35,131,17);

   lblVersion = new QLabel(this, "lblVersion");
   lblVersion->setText("beta 1");
   lblVersion->setFont(QFont("Times",10,QFont::Normal,(int)1));
   lblVersion->setAlignment(AlignLeft | AlignTop);
   lblVersion->setGeometry(238,16,50,16);

   btnOK = new QPushButton(this, "btnOK");
   btnOK->setText("&OK");
   btnOK->setDefault(true);
   btnOK->setAccel( Key_Escape );
   btnOK->setGeometry(215,160,73,26);
   btnOK->setFont( QFont( "", 10 ) );

   lblThanks = new QLabel(this, "lblThanks");
   lblThanks->setText("\nSpecial Thanks:\n\t\tThe author of Licq\n\t\tSeth Ciango\n\t\tMichael Agapito");
   lblThanks->setAlignment(AlignLeft | AlignTop);
   lblThanks->setGeometry(131,53,161,88);

   connect( btnOK, SIGNAL(clicked()), this, SLOT(hide()));
}


//
// ----infoDialog ---------------------------------------------
//

UserInfoDlg::UserInfoDlg(ICQ *s, ICQUser *u, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   theUser = u;
   server = s;
   char caption[50];

   setIcon(QPixmap(info_xpm));
   sprintf(caption, "User Info On: %s", theUser->alias());
   setCaption( caption );
   setFixedSize(348,233);


   lblLastName = new QLabel(this, "lblLastName");
   lblLastName->setText("Last Name");
   lblLastName->setAlignment(AlignLeft | AlignTop);
   lblLastName->setGeometry(185,110,131,13);
   lblLastName->setFont( QFont( "", 10 ) );

   lblUIN = new QLabel(this, "lblUIN");
   lblUIN->setText("ICQ#");
   lblUIN->setAlignment(AlignLeft | AlignTop);
   lblUIN->setGeometry(23,25,44,13);
   lblUIN->setFont( QFont( "", 10 ) );

   lblCurrentIP = new QLabel(this, "lblCurrentIP");
   lblCurrentIP->setText("Current / Last I.P. Number");
   lblCurrentIP->setAlignment(AlignLeft | AlignTop);
   lblCurrentIP->setGeometry(185,25,131,13);
   lblCurrentIP->setFont( QFont( "", 10 ) );

   lblNickname = new QLabel(this, "lblNickname");
   lblNickname->setText("Nickname");
   lblNickname->setAlignment(AlignLeft | AlignTop);
   lblNickname->setGeometry(23,67,57,13);
   lblNickname->setFont( QFont( "", 10 ) );

   lblEmail = new QLabel(this, "lblEmail");
   lblEmail->setText("Email");
   lblEmail->setAlignment(AlignLeft | AlignTop);
   lblEmail->setGeometry(185,67,131,13);
   lblEmail->setFont( QFont( "", 10 ) );

   lblFirstName = new QLabel(this, "lblFirstName");
   lblFirstName->setText("First Name");
   lblFirstName->setAlignment(AlignLeft | AlignTop);
   lblFirstName->setGeometry(23,110,67,13);
   lblFirstName->setFont( QFont( "", 10 ) );


   edtUIN = new QLineEdit(this, "edtUIN");
   edtUIN->setGeometry(22,40,145,21);
   edtUIN->setEnabled(false);
   edtUIN->setText("272461");
   edtUIN->setFont( QFont( "", 10 ) );
 
   edtNickname = new QLineEdit(this, "edtNickname");
   edtNickname->setGeometry(22,82,145,21);
   edtNickname->setEnabled(false);
   edtNickname->setFont( QFont( "", 10 ) );

   edtFirstName = new QLineEdit(this, "edtFirstName");
   edtFirstName->setGeometry(22,125,145,21);
   edtFirstName->setEnabled(false);
   edtFirstName->setFont( QFont( "", 10 ) );

   edtCurrentIP = new QLineEdit(this, "edtCurrentIP");
   edtCurrentIP->setGeometry(184, 40, 145, 21);
   edtCurrentIP->setEnabled(false);
   edtCurrentIP->setFont( QFont( "", 10 ) );

   edtEmail = new QLineEdit(this, "edtEmail");
   edtEmail->setGeometry(184,82,145,21);
   edtEmail->setEnabled(false);
   edtEmail->setFont( QFont( "", 10 ) );

   edtLastName = new QLineEdit(this, "edtLastName");
   edtLastName->setGeometry(184,125,145,21);
   edtLastName->setEnabled(false);
   edtLastName->setFont( QFont( "", 10 ) );

   btnDone = new QPushButton(this, "cmdDone");
   btnDone->setText("Done");
   btnDone->setGeometry(184,204,54,22);
   btnDone->setFont( QFont( "", 10 ) );

   btnUpdate = new QPushButton(this, "cmdUpdate");
   btnUpdate->setText("Update");
   btnUpdate->setGeometry(244,204,54,22);
   btnUpdate->setFont( QFont( "", 10 ) );


   lblAnimation = new AnimatedUserLabel(this);
   lblAnimation->setAlignment(AlignLeft | AlignTop);
   lblAnimation->setGeometry(303,190,36,36);
   lblAnimation->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
   lblAnimation->setAlignment( AlignCenter | AlignCenter );
   lblAnimation->setPixmap( QPixmap(search0_xpm));

   connect( btnDone, SIGNAL(clicked()), this, SLOT(hide()) );
   connect( btnUpdate, SIGNAL(clicked()), this, SLOT(updateUser()) );

   connect( server, SIGNAL(doneUserInfo(bool, unsigned long)), this, SLOT(updatedUserInfo(bool, unsigned long)) );


   // get user info and such
   if (theUser->newUser())
   {
      theUser->setNewUser(false);
      theUser->saveInfo();
      //emit updatedUsers();
   }

  updatedUserInfo(true, theUser->uin());

}

void UserInfoDlg::updatedUserInfo(bool isOk, unsigned long uin)
{
   if (uin != theUser->uin()) return;

   if (isOk){
      struct UserStatusline us;
      theUser->getStatusInfo(us);
      edtNickname->setText(us.alias);
      edtFirstName->setText(us.firstname);
      edtLastName->setText(us.lastname);
      edtEmail->setText(us.email);
      edtUIN->setText(us.uin);
      edtCurrentIP->setText(us.ip_port);

      btnUpdate->setEnabled( true );
      lblAnimation->stop();
   }
}

void UserInfoDlg::updateUser()
{
   if (server->getUserInfo(theUser))
   {
       if (theUser->newUser()) {
         theUser->setNewUser(false);
         //emit updatedUsers();
       }

      theUser->saveInfo();
      
      lblAnimation->start();
      btnUpdate->setEnabled( false );
   }
}

void UserInfoDlg::hide()
{
   QDialog::hide();
   
   theUser->infoDlg = NULL;
   delete this;

// this needs to be fixed ?

   //if (icqEvent != NULL) server->cancelEvent(icqEvent);
   //emit finished(theUser, 8);
}



//
// ----renameDialog ---------------------------------------------
//


UserRenameDlg::UserRenameDlg (ICQUser *u, QWidget *parent = NULL, const char *name = NULL) : QDialog(parent, name)
{
   theUser = u;
   char temp[50];

   setIcon(QPixmap(renameuser_xpm));
   sprintf(temp, "Rename %s", theUser->alias());
   setCaption( temp );
   setFixedSize(188,108);

   lblDescription = new QLabel(this, "lblDescription");
   sprintf(temp, "Rename user %s to:", theUser->alias());
   lblDescription->setText( temp );
   lblDescription->setAlignment(AlignLeft | AlignTop);
   lblDescription->setGeometry(12,8,176,20);
   lblDescription->setFont( QFont( "", 10 ) );

   edtNickname = new QLineEdit(this, "edtNickname");
   edtNickname->setGeometry(13,30,159,20);
   edtNickname->setFocus();

   btnRename = new QPushButton(this, "btnRename");
   btnRename->setText("Rename");
   btnRename->setGeometry(13,76,66,22);
   btnRename->setFont( QFont( "", 10 ) );
   btnRename->setDefault( true );

   btnCancel = new QPushButton(this, "btnCancel");
   btnCancel->setText("Cancel");
   btnCancel->setGeometry(107,76,66,22);
   btnCancel->setFont( QFont( "", 10 ) );


   connect( btnRename, SIGNAL(clicked()), this, SLOT(renameUser()) );
   connect( btnCancel, SIGNAL(clicked()), this, SLOT(hide()) );
}

void UserRenameDlg::renameUser()
{

    sprintf(theUser->aliasVal, "%s", (const char *)edtNickname->text());
    theUser->saveInfo();

    emit finished(theUser, 9);
}

void UserRenameDlg::hide()
{
   QDialog::hide();

// this needs to be fixed ?

   //if (icqEvent != NULL) server->cancelEvent(icqEvent);
   emit finished(theUser, 9); 
}



//
// ----searchDialog ---------------------------------------------
//


SearchUserView::SearchUserView(QWidget *parent = NULL, char *name = NULL) : QListView(parent, name)
{
   addColumn("ICQ #", 60);
   addColumn("Nick Name", 75);
   addColumn("Full Name", 105);
   addColumn("Email", 130);
   setAllColumnsShowFocus (true); 
}


unsigned long SearchUserView::currentUin(void)
{
   if (currentItem() == NULL) return (0);
   return (((SearchItem *)currentItem())->uin());
}


SearchItem::SearchItem(struct UserStatusline &us, QListView *parent) : QListViewItem(parent)
{
   uinVal = (unsigned long)atol(us.uin);
   setText(0, us.uin);
   setText(1, us.alias);
   setText(2, us.name);
   setText(3, us.email);
}


unsigned long SearchItem::uin(void)
{
   return (uinVal);
}



ICQSearchDlg::ICQSearchDlg (ICQ *s, QWidget *parent = NULL, const char *name = NULL) : QDialog(parent, name) 
{
   setFixedSize(381, 208);
   setCaption("ICQ Global Directory Search Engine");
   setIcon( QPixmap(addsearch_xpm));
   server = s;

   grpDialog = new QButtonGroup( this, "grpDialog" );
   grpDialog->setAlignment(AlignLeft | AlignTop);
   grpDialog->setGeometry(1,1,378,205);
   grpDialog->setFrameStyle(QFrame::Panel | QFrame::Sunken);

   grpSearchButtons = new QButtonGroup( this, "grpSearchButtons" );   grpSearchButtons->setGeometry(274,14,99,182);
   grpSearchButtons->setFrameStyle(QFrame::Box | QFrame::Sunken);
 

   btnSearch= new QPushButton(grpSearchButtons, "btnSearch");
   btnSearch->setText("Search");
   btnSearch->setGeometry(10,9,77,33);
   btnSearch->setDefault( true );
   btnSearch->setFont( QFont( "", 10 ) );

   btnStopSearch= new QPushButton(grpSearchButtons, "btnStopSearch");
   btnStopSearch->setText("Stop Search");
   btnStopSearch->setGeometry(10,46,77,28);
   btnStopSearch->setFont( QFont( "", 10 ) );
   btnStopSearch->setEnabled( false );

   btnNewSearch = new QPushButton(grpSearchButtons, "btnNewSearch");
   btnNewSearch->setText("New Search");
   btnNewSearch->setGeometry(10,80,77,28);
   btnNewSearch->setFont( QFont( "", 10 ) );

   lblAnimation = new AnimatedUserLabel(grpSearchButtons);
   lblAnimation->setGeometry(32,116,36,36);


/*   tabEmail = new QWidget(this);
   tabEmail->setGeometry(0, 0, 200, 200);
   
   tabSearchBar->addTab(tabEmail); */

   lblEmail = new QLabel(this);
   lblEmail->setGeometry(13, 20, 60, 20);
   lblEmail->setFont( QFont( "", 10 ) );
   lblEmail->setText("Email:");
   
   edtEmail = new QLineEdit(this);
//   edtEmail->setGeometry(80,125,170,20);
   edtEmail->setGeometry(75, 20, 159, 20);
   edtEmail->setFont( QFont( "", 10 ) );
   edtEmail->setFocus();


   lblNick = new QLabel(this);
   lblNick->setGeometry(13, 50, 60, 20);
   lblNick->setFont( QFont( "", 10 ) );
   lblNick->setText("Nickname:");

   edtNick = new QLineEdit(this);
   edtNick->setFont( QFont( "", 10 ) );
   edtNick->setGeometry(75, 50, 159, 20);


   lblFirstName = new QLabel(this);
   lblFirstName->setGeometry(13, 80, 60, 20);
   lblFirstName->setFont( QFont( "", 10 ) );
   lblFirstName->setText("First Name:");

   edtFirstName = new QLineEdit(this);
   edtFirstName->setFont( QFont( "", 10 ) );
   edtFirstName->setGeometry(75, 80, 159, 20);
   

   lblLastName = new QLabel(this);
   lblLastName->setGeometry(13, 110, 60, 20);
   lblLastName->setFont( QFont( "", 10 ) );
   lblLastName->setText("Last Name:");

   edtLastName = new QLineEdit(this);
   edtLastName->setFont( QFont( "", 10 ) );
   edtLastName->setGeometry(75, 110, 157, 20);


   foundView = new SearchUserView(this);
   foundView->setGeometry(2, 212, 378, 143);
   foundView->setFont( QFont( "", 10 ) );
   foundView->setStyle(WindowsStyle);
   foundView->setFrameStyle(QFrame::Box | QFrame::Raised);


   connect( btnSearch, SIGNAL(clicked()), this, SLOT(beginSearch()) );
   connect( btnStopSearch, SIGNAL(clicked()), this, SLOT(stopSearch()) );
   connect( btnNewSearch, SIGNAL(clicked()), this, SLOT(newSearch()) );
   connect (foundView, SIGNAL(doubleClicked(QListViewItem *)), this, SLOT(addUser()));
   connect (server, SIGNAL(userFound(struct UserStatusline &, unsigned long)), 
            this, SLOT(userFound(struct UserStatusline &, unsigned long)));
   connect (server, SIGNAL(doneSearch(unsigned short, char)), 
            this, SLOT(doneSearch(unsigned short, char)));
 
}

void ICQSearchDlg::show()
{
   newSearch();
   QDialog::show();
}

void ICQSearchDlg::beginSearch()
{

   lblAnimation->start();
   btnSearch->setEnabled( false );
   btnStopSearch->setEnabled( true );
   btnStopSearch->setDefault( true );
   foundView->clear();

   searchSequence = server->icqOwner.searchSequence();
   server->startSearch((char *)edtNick->text(),
                       (char *)edtFirstName->text(),
                       (char *)edtLastName->text(),
                       (char *)edtEmail->text(),
                       searchSequence);

//   foundView->clear();
   edtNick->setEnabled(false);
   edtFirstName->setEnabled(false);
   edtLastName->setEnabled(false);
   edtEmail->setEnabled(false);
//   btnAdd->setEnabled(false);
//   lblSearch->setText("Searching (this can take awhile)...");
   setFixedSize(381, 358);
}

void ICQSearchDlg::stopSearch()
{
   lblAnimation->stop();
   btnSearch->setEnabled( true );
   btnSearch->setDefault( true );
   btnStopSearch->setEnabled( false );

   edtNick->setEnabled(true);
   edtFirstName->setEnabled(true);
   edtLastName->setEnabled(true);
   edtEmail->setEnabled(true);

}

void ICQSearchDlg::newSearch()
{
   stopSearch();


   edtNick->clear();
   edtFirstName->clear();
   edtLastName->clear();
   edtEmail->clear();
   foundView->clear();
   
   setFixedSize(381, 208);

}

void ICQSearchDlg::userFound(struct UserStatusline &us, unsigned long s = 0)
{
   if (s == searchSequence)
   {  
      (void) new SearchItem(us, foundView);
      //if (!btnAdd->isEnabled()) btnAdd->setEnabled(true);
   }
}


void ICQSearchDlg::doneSearch(unsigned short s, char more)
{
  stopSearch();
  if (s == searchSequence)
    if (more == (char)1)
      QMessageBox::information( this, "ICQnix", "Search returned too many results. Narrow search", QMessageBox::Ok, 0);
/*    else
      lblSearch->setText("Search complete."); */
}

void ICQSearchDlg::addUser()
{
   unsigned long uin = foundView->currentUin();
   if (uin == 0) return;
   if (!server->knownUser(uin))  // make sure not to add a user we already have
       server->addUser(uin, NULL, true );
   //foundView->clear();
} 
