#ifndef ICQnixGUI_included
#define ICQnixGUI_included

#include <qapp.h>
#include <qwidget.h>
#include <qcombo.h>
#include <qmenubar.h>
#include <qpopmenu.h>
#include <qlistbox.h>
#include <qgrpbox.h>
#include <qtimer.h>
#include <qtimer.h>
#include <qpushbutton.h>
//#include <qsplitter.h>

#include "icq.h"
#include "outputwin.h"
#include "icqfunctions.h"
#include "userbox.h"
#include "awaymsgdlg.h"
#include "adduserdlg.h"
#include "authuserdlg.h"
#include "chatdlg.h"
#include "connectbutton.h"
#include "icqdialogs.h"

class NewLabel : public QLabel
{
   Q_OBJECT
public:
   NewLabel(QWidget *parent = 0);
   void setBold(bool);
   void setItalic(bool);
   void setNamedColor(char *);
protected:
   virtual void mouseDoubleClickEvent(QMouseEvent *);
signals:
   void doubleClicked();
};

//=====ICQnixGUI=====================================================================================
class ICQnixGUI: public QWidget
{
   Q_OBJECT
public:
   ICQnixGUI(ICQ *theServer, QWidget *parent = 0, const char *name = 0);
   ~ICQnixGUI(void);
protected:
   ICQ *server;
   OutputWin *netWin;
   AwayMsgDlg *awayMsgDlg;
   AddUserDlg *addUserDlg;
   AuthUserDlg *authUserDlg;
   AboutDlg *aboutBox;
   SendMessageDlg *newMessageDlg;
   ICQSearchDlg *searchUserDlg;
   ChatDlg *chatDlg;
   HistoryDlg *dlgHistory;

   ICQFunctions *icqFunctions;
   //UserView *userViewOnline, *userViewOffline;
   //QSplitter *splUser;
   UserView *userView;
   QPopupMenu *mnuSystem, *mnuUser, *mnuAdvanced, *mnuOptions, *mnuColumns, *mnuDebug, *mnuSound, *mnuVisible;
   ICQPopupMenu *mnuFile, *mnuStatus;
   QGroupBox *statusBar;
   NewLabel *lblStatus, *lblSysMsg, *lblMsg;
   PopupButton *cmdStatus;
   QPushButton *cmdICQ, *cmdSearch;
   char fontFamily[32],
        colorOnline[32], colorAway[32], colorPrivate[32], colorPrivateBack[32], colorOffline[32], colorNew[32], 
        colorOnlineBack[32], colorAwayBack[32], colorOfflineBack[32];
   QFont::CharSet fontCharSet;
   QPixmap *pmOnline, *pmFreeForChat, *pmOffline, *pmAway, *pmDnd, *pmOccupied, *pmNa, *pmPrivate, *pmMessage;
   int timerid;
   unsigned short msgs;
   unsigned short fontSize;
   unsigned short logonNow;
   QTimer autoAwayTimer;
   unsigned short autoAwayTime, autoNATime;
   bool inMiniMode, gridLines, switchMessagePixmap;

   void resizeEvent (QResizeEvent *);
   void callICQFunction(int fcn, bool isUser);

   virtual void timerEvent(QTimerEvent *);
 
protected slots:
   void removeUser();
   void updateUserWin();
   void updateStatus();
   void changeStatus(int index);
   void callDefaultICQFunction();
   void callICQOwnerFunction();
   void callICQUserFunction(int fcn);
   void killICQFunction(ICQUser *u, int window);
   void eventResult(ICQUser *, unsigned short, bool, unsigned long);
   void done(bool isOk, unsigned short cmd);
   void changeDebug(int);
   void toggleGridLines();
   void changeSound(int);
   void miniMode();
   void nextServer();
   void autoAway();
   void statusCommand();
   void depressButton();
   void icqCommand();
   void readSysMsg();
   void readSysMsgHistory();   
   void changeStatusIcon(QPixmap newIcon);   


signals:
   void changeDockStatus(unsigned short int);

};


#endif
